RegisterAddonMessagePrefix("HavenLootsNew");
RegisterAddonMessagePrefix("HavenLootsRoll");
RegisterAddonMessagePrefix("HavenLootsRes");
RegisterAddonMessagePrefix("HavenLootsClear");

--##########################################################################
-- class variables
local numberOfRolls = {};
local alts = {};
local requiredLoot = {};
local requiredLootSize = 0;
local sendType = "RAID";

--##########################################################################
-- master looter check
local function IsMasterLooter()
	local _, _, ID = GetLootMethod();
	if ID == nil or UnitName("raid" ..ID) ~= UnitName("player") then
		return false;
	end
	return true;
end

--##########################################################################
-- add loot rolls
local function AddLootRoll(itemNumber, name, rollType)
	SendAddonMessage("HavenLootsRes", name .." "..rollType .." " ..math.random(100) + (rollType * 100) .." " ..itemNumber, sendType);
end

--##########################################################################
-- send loot table
local function LootOpened()
	if IsMasterLooter() ~= true then return end
	for i = 1, 20 do
		local link = GetLootSlotLink(i);
		if link ~= nil then
			SendAddonMessage("HavenLootsNew", link, sendType);
		end
	end
end

--##########################################################################
-- recieve messages
local function isAlt(name)
	for i = 1, table.getn(alts) do
		if alts[i] == name then
			return true;
		end
	end
	return false;
end

local getRoll = CreateFrame("FRAME");
getRoll:RegisterEvent("CHAT_MSG_ADDON");
local function GetRoll(self, event, prefix, message, channel, sender)
	if IsMasterLooter() ~= true then return end
	if prefix == "HavenLootsRoll" then
		words = {}
		for word in message:gmatch("%w+") do table.insert(words, word) end
		local itemNumber = tonumber(words[1]);
		local rollType = tonumber(words[2]);
		if isAlt(sender) then
			if rollType > 2 then
				rollType = rollType - 1;
			end
		end
		AddLootRoll(itemNumber, sender, rollType);
	end
end
getRoll:SetScript("OnEvent", GetRoll)

--##########################################################################
-- set alts
local function NameIsInRaid(input)
	for i = 1, 40 do
		local name = GetRaidRosterInfo(i);
		if name == input then
			return true;
		end
	end
	return false;
end

local function TakeFromAlt(input)
	for i = 1, table.getn(alts) do
		if alts[i] == input then
			table.remove(alts, i);
			return true;
		end
	end
	return false;
end

SLASH_HLS1 = '/hls';
function SlashCmdList.HLS(msg, editbox)
	if IsMasterLooter() ~= true then return end
	words = {}
	for word in msg:gmatch("[^%s]+") do table.insert(words, word) end
	if words[1] == "alt" then
		table.insert(alts, words[2]);
		SendChatMessage("[Haven Loots] You have been marked as an alt! This means you will be given a lower priority on loot rolls. Roll as if you were a main and the addon will do the rest. Whisper me if this is incorrect!", "WHISPER", "Common", words[2]);
		DEFAULT_CHAT_FRAME:AddMessage("[HavenLoots]: " ..words[2] .." added to alts.", 1, 1, 0);
	end
	if words[1] == "altremove" then
		local success = TakeFromAlt(words[2]);
		SendChatMessage("[Haven Loots] You are no longer marked as an alt. Lucky you!", "WHISPER", "Common", words[2]);
		DEFAULT_CHAT_FRAME:AddMessage("[HavenLoots]: " ..words[2] .." cleared from alts.", 1, 1, 0);
	end
	if words[1] == "altclear" then
		alts = {};
		DEFAULT_CHAT_FRAME:AddMessage("[HavenLoots]: Alts Cleared", 1, 1, 0);
		SendChatMessage("[Haven Loots] All loot data has been cleared!", "RAID", "Common");
	end
	if words[1] == "clear" then
		SendAddonMessage("HavenLootsClear", " ", sendType);
		DEFAULT_CHAT_FRAME:AddMessage("[HavenLoots]: Cleared the loot tables.", 1, 1, 0);
	end
	if words[1] == "broadcast" then
		LootOpened();
		SendChatMessage("[Haven Loots] Loot data has been sent! If you do not have the Haven Loots addon you will not see this data.", "RAID", "Common");
		DEFAULT_CHAT_FRAME:AddMessage("[HavenLoots]: Loot broadcast sent.", 1, 1, 0);
	end
end
--##########################################################################